#ifndef __EMIT_HH__
#define __EMIT_HH__

#include "archi.hh"
#include "sched.hh"

#include <iostream>
#include <string>
#include <sstream>


/**
 * The emitter emits code to stdout.
 *
 * @todo LABELV: a) Should not use the ordinary slot_row_suffix.
 *               b) Should "label-rows" always use implicit nops?
 *               c) Not ordinary slot_row_prefix either.
 */
class Emitter
{
private:
  char *slot_row_prefix;
  char *slot_separator;
  char *slot_row_suffix;
  char *NOP_string;
  bool implicit_nops;
  
  void emit_list(std::vector<std::vector<Schedule::slot_t> > &s);  
  void emit_row(std::vector<Schedule::slot_t> &r);
  void emit_slot(Schedule::slot_t &slot);
  
  bool error_has_occured_on_current_row;
  std::ostringstream rowerrors;
  
  int row_count;
  
public:
  Emitter(Architecture *architecture);
  ~Emitter();
  void emit(Schedule *s);
  
  static bool always_mnemonic; // -emitter:mnemonic
  static bool debug_mode; // -emitter:debug
};

#endif //__EMIT_HH__
