#include <iostream>
#include "flags.hh"

bool Flags::b_vcg = false;
bool Flags::b_dot = false;
int Flags::i_bb = -1;
int Flags::i_hs = 0;
int Flags::i_ts = 0;
Flags::opt_type_t Flags::opt_type = Flags::TIME;
bool Flags::b_ilp = false;
bool Flags::no_ddep_link = false;
char* Flags::architecture_file = NULL;
char* Flags::program_file = NULL;

//oskar:
bool Flags::b_ga_pthreads = false;
unsigned int Flags::i_ga_max_gen = -1;
unsigned int Flags::i_ga_size = 20;
unsigned int Flags::i_ga_stable_stop = 30;
double Flags::d_ga_mutate_node = 5.0;
double Flags::d_ga_mutate_inst = 5.0;
double Flags::d_ga_mutate_transfer = 5.0;
double Flags::d_ga_new_children = 100;
bool Flags::b_ga_allow_multiple_mutations = true;
bool Flags::b_ga_parents_survive = true;
bool Flags::b_ga_survivor_truncation = false;
bool Flags::b_ga_survivor_roulette = true;
bool Flags::b_ga_bench = false;
bool Flags::b_ga_random_search = false;

Flags::Flags()
{
}

Flags::~Flags()
{
}

void Flags::usage(void)
{
  std::cerr << "\nUsage:\n"
    "  -archi=<XML file>     Specify target architecture file.\n"
    "  -vcg                  Generate DAGs in VCG format.\n"
    "  -dot                  Generate DAGs in dot format.\n"
    "  -bb=<n>               Generate code for BB number n.\n"
    "  -hs=<n>               Heuristic: at each z generate at most n variants.\n"
    "  -ts=<n>               Heuristic: at each stage generates at most n transfers.\n"
    "  -verb=[1,2,3,4]       Verbosity level.\n"
    "  -?                    Show this help.\n"
    "  -emitter:mnemonic     Prints the mnemonics instead of FORMAT assembler\n"
    "  -emitter:debug        Prints mnemonics next to the assembler\n"
    "  -opt_c_debug          Shows calls to back-end events\n"
    "  -arm_asm              Assembler directives and declarations for ARM\n"
    "  -ilp                  Generates ILP data\n"
    "  -ddep                 Remove DDEP and LINK edges (resulting code might be erronous)\n"
    // oskar:
    "  -opt=g                Use genetic algorithms.\n"
    "  -gasize=<n>               Number of individuals to use.\n"
    "  -gamaxgen=<n>             Max number of generations to run.\n"
    "  -gastable_stop=<n>        Stop evolution after this number of generations\n"
    "                            with stable fitness. 0 to disable.\n"
    "  -gamutate_node=<%>        0.0-100.0 float % TODO\n"
    "  -gamutate_inst=<%>        0.0-100.0 float % TODO\n"
    "  -gamutate_transfer=<%>    0.0-100.0 float % TODO\n"
    "  -gaparents_survive        Allow parents to survive to the next generation.\n"
    "  -ganoparents_survive      Do not allow parents to survive.\n"
    "  -ganew_children=<%>       0.0-x float % of new children to make TODO\n"
    "  -gamultiple               Allow multiple mutations per child.\n"
    "  -ganomultiple             Do not allow multiple mutations per child.\n"
    "  -gasurvivor_truncation    Select survivors with truncation.\n"
    "  -gasurvivor_roulette      Select survivors with roulette wheel.\n"
    "  -garandom_search          Search randomly instead of using the genetic algorithm\n"
    "  -gapthreads               Use one thread per individual.\n"
	    << std::endl;
}
