#ifndef __GAINSTCAND_HH__
#define __GAINSTCAND_HH__

#include "tinst.hh"
#include "pudag.hh"
#include "node.hh"
#include "pattern.hh"


namespace GA
{


enum InstructionType {
  NO_INSTRUCTION,
  NORMAL_INSTRUCTION,
#ifdef _TRANS_
  TRANSFER_INSTRUCTION,
#endif
};
  

class InstructionCandidate
{
public:
  InstructionCandidate(TargetInstruction* _tinst, InstructionType _type, const vertex_set_t& _chi,
                 const iso_map_s& _iso_map, pattern_t* _pattern)
    : tinst(_tinst), type(_type), chi(_chi), iso_map(_iso_map), pattern(_pattern) {}
  ~InstructionCandidate();
  
  InstructionCandidate(const InstructionCandidate& _instcand);
  const InstructionCandidate& operator=(const InstructionCandidate& _instcand);
  
  TargetInstruction* tinst;
  enum InstructionType type;
  vertex_set_t chi;
  iso_map_s iso_map;
  pattern_t* pattern;
  
private:
  void copy_instcand(const InstructionCandidate& _instcand);

};

};


#endif //__GAINSTCAND_HH__
