/*
 * Verbosity level is set by -verb=
 */
#ifndef __VERBOSE_HH__
#define __VERBOSE_HH__

#include <iostream>

class Verbose {

public:
  Verbose(int l, bool active = true) {
    level = l;
  }

  bool isActive() const {
    return level <= verbosityLevel;
  }

  static int verbosityLevel;
  static std::ostream *stream;

private:
  int level;

};

template<class T>
inline Verbose &operator<<(Verbose &_out, T data) {
  if (_out.isActive()) {
    *Verbose::stream << data;
  }
  return _out;
}

extern Verbose VERB1, VERB2, VERB3, VERB4;

#endif //__VERBOSE_HH__
